View Issue Details

IDProjectCategoryView StatusLast Update
0032758Open CASCADEOCCT:Visualizationpublic2022-01-15 14:37
Reporterkgv Assigned Tokgv  
PrioritynormalSeverityminor 
Status verifiedResolutionfixed 
Product Version7.6.0 
Target Version7.7.0 
Summary0032758: Visualization, TKOpenGl - disable shadow-map from transform-persistence objects
DescriptionTransform-persistence / text flipping (OpenGl_Flipper) do not work correctly within shadow-mapping - shadow position doesn't depend on display position based on real camera position.

It is proposed just disabling shadow map for such objects (them already do not receive shadows, now they will not cast shadows) to avoid artifacts, and consider implementing shadow casting only if there will be found some useful scenarios for this.
Steps To Reproduce
pload MODELING VISUALIZATION
vinit View1
vcamera -persp
vrenderparams -shadows
vlight headlight -castShadows 1 -head 0 -dir -1 -1 -1
vtrihedron trih

box g -250 -250 0 500 500 0 -preview
vdisplay -dispMode 1 g
vaspects g -color GRAY60

box b 20 10 50
vdisplay -dispMode 1 b -trsfPers ZOOM -trsfPersPos 0 0 0


pload MODELING VISUALIZATION
box b -250 -250 0 500 500 0 -preview
vinit View1
vtrihedron trih
vdisplay -dispMode 1 b
vcamera -persp
#vremove t1
vdrawtext t1 "First line\nSecond line" -pos 10 0 0 -color red -plane 1 0 0 0 1 0 -halign center -valign top -height 50
#vdrawtext t1 "First line\nSecond line" -pos 10 0 0 -color red -plane 1 0 0 0 1 0 -flipping -halign center -valign top -height 50
vlocation t1 -translate 0 10 150
vrenderparams -shadows
vlight headlight -castShadows 1 -head 0 -dir -1 1 -1
TagsNo tags attached.
Test case numberopengl shadows trsfpers

Attached Files

  • zoompers_shadow_KO.png (9,084 bytes)

Relationships

child of 0032039 closedbugmaster Visualization, TKOpenGl - implement simple shadow mapping for a direct light source 

Activities

kgv

2021-12-30 16:18

developer   ~0106246

zoompers_shadow_KO.png (9,084 bytes)

git

2021-12-30 17:07

administrator   ~0106247

Branch CR32758 has been created by kgv.

SHA-1: 65a71f59f7ced5d07076f7f33d56d30a177e0274


Detailed log of new commits:

Author: kgv
Date: Thu Dec 30 17:07:18 2021 +0300

    Try some camera hacks (non-working).

Author: kgv
Date: Thu Dec 30 16:56:36 2021 +0300

    OpenGl_Context::ApplyPersistence() - moved from OpenGl_Structure::applyPersistence()

Author: kgv
Date: Thu Dec 30 16:41:09 2021 +0300

    0032758: Visualization, TKOpenGl - wrong shadow-map within transform-persistence
    
    Improved syntax of vdrawtext command.

git

2021-12-30 20:21

administrator   ~0106248

Branch CR32758_1 has been created by kgv.

SHA-1: 1e77e5bfd1e6b640ef16d1b1bedab86fea263843


Detailed log of new commits:

Author: kgv
Date: Thu Dec 30 16:41:09 2021 +0300

    0032758: Visualization, TKOpenGl - disable shadow-map from transform-persistence objects
    
    OpenGl_View::renderShadowMap() now skips transform-persistent objects.
    Improved syntax of vdrawtext command.

git

2021-12-30 20:31

administrator   ~0106249

Branch CR32758_1 has been updated forcibly by kgv.

SHA-1: f93525fcdcdc4d797e473326bbcb271af634c463

kgv

2021-12-30 22:11

developer   ~0106250

Patch is ready for review
- OCCT: branch CR32758_1.

http://jenkins-test-occt/view/CR32758_1-master-KGV

osa

2022-01-10 14:22

developer   ~0106280

The patch was reviewed

smoskvin

2022-01-15 14:07

administrator   ~0106389

Combination -
OCCT branch : IR-2022-01-14
master SHA - 71943b31f820c2b9191854299241dd82c2716eaf
49e51745631c52b6c452c65adae4d6dfa21a1b1e
Products branch : IR-2022-01-14 SHA - 13a1d612d3ecdc2ed1a10120341e9df4c3d9fd2e
was compiled on Linux, MacOS and Windows platforms and tested in optimize mode.

Number of compiler warnings:
No new/fixed warnings

Regressions/Differences/Improvements:
No regressions/differences

CPU differences:
Debian80-64:
OCCT
Total CPU difference: 18239.750000000447 / 18223.400000000463 [+0.09%]
Products
Total CPU difference: 11656.240000000102 / 11659.240000000125 [-0.03%]
Windows-64-VC14:
OCCT
Total CPU difference: 19987.609375 / 20012.3125 [-0.12%]
Products
Total CPU difference: 13139.84375 / 13120.265625 [+0.15%]


Image differences :
No differences that require special attention

Memory differences :
No differences that require special attention

git

2022-01-15 14:37

administrator   ~0106403

Branch CR32758 has been deleted by mnt.

SHA-1: 65a71f59f7ced5d07076f7f33d56d30a177e0274

git

2022-01-15 14:37

administrator   ~0106404

Branch CR32758_1 has been deleted by mnt.

SHA-1: f93525fcdcdc4d797e473326bbcb271af634c463

Related Changesets

occt: master d9254973

2021-12-30 16:41:09

kgv


Committer: smoskvin Details Diff
0032758: Visualization, TKOpenGl - disable shadow-map from transform-persistence objects

OpenGl_View::renderShadowMap() now skips transform-persistent objects.
OpenGl_ShadowMap::UpdateCamera() - removed redundant Z-range expansion for non-rendered objects.
Improved syntax of vdrawtext command.
Affected Issues
0032758
mod - src/OpenGl/OpenGl_Group.hxx Diff File
mod - src/OpenGl/OpenGl_RenderFilter.hxx Diff File
mod - src/OpenGl/OpenGl_ShadowMap.cxx Diff File
mod - src/OpenGl/OpenGl_View.cxx Diff File
mod - src/OpenGl/OpenGl_Workspace.cxx Diff File
mod - src/ViewerTest/ViewerTest_ObjectCommands.cxx Diff File
add - tests/opengl/data/shadows/trsfpers Diff File

Issue History

Date Modified Username Field Change
2021-12-30 15:38 kgv New Issue
2021-12-30 15:38 kgv Assigned To => kgv
2021-12-30 16:18 kgv Note Added: 0106246
2021-12-30 16:18 kgv File Added: zoompers_shadow_KO.png
2021-12-30 16:18 kgv Steps to Reproduce Updated
2021-12-30 16:40 kgv Summary Visualization, TKOpenGl - bake 360 spherical panorama background into cubemap => Visualization, TKOpenGl - wrong shadow-map within transform-persistence
2021-12-30 16:41 kgv Steps to Reproduce Updated
2021-12-30 17:07 git Note Added: 0106247
2021-12-30 20:16 kgv Relationship added child of 0032039
2021-12-30 20:17 kgv Summary Visualization, TKOpenGl - wrong shadow-map within transform-persistence => Visualization, TKOpenGl - disable shadow-map from transform-persistence objects
2021-12-30 20:21 git Note Added: 0106248
2021-12-30 20:31 git Note Added: 0106249
2021-12-30 22:11 kgv Description Updated
2021-12-30 22:11 kgv Test case number => opengl shadows trsfpers
2021-12-30 22:11 kgv Assigned To kgv => osa
2021-12-30 22:11 kgv Status new => resolved
2021-12-30 22:11 kgv Note Added: 0106250
2022-01-10 14:22 osa Assigned To osa => bugmaster
2022-01-10 14:22 osa Status resolved => reviewed
2022-01-10 14:22 osa Note Added: 0106280
2022-01-15 14:07 smoskvin Status reviewed => tested
2022-01-15 14:07 smoskvin Note Added: 0106389
2022-01-15 14:26 smoskvin Changeset attached => occt master d9254973
2022-01-15 14:26 kgv Assigned To bugmaster => kgv
2022-01-15 14:26 kgv Status tested => verified
2022-01-15 14:26 kgv Resolution open => fixed
2022-01-15 14:37 git Note Added: 0106403
2022-01-15 14:37 git Note Added: 0106404